﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WpfTimeConsumingApp
{
    public class TimeConsumingJob : IEnumerator<double>, System.ComponentModel.INotifyPropertyChanged
    {
        #region Variables
        bool _disposed = false;
        double _maximum = 100, _minimum = 0, _value = 0;
        string _message = string.Empty;
        int _cnt = 0;
        #endregion

        /// <summary>
        /// PropertyChangedEvent を発生します
        /// </summary>
        protected void OnPropertyChangedEvent(string propName)
        {
            if (null != this.PropertyChanged)
                this.PropertyChanged(this, new System.ComponentModel.PropertyChangedEventArgs(propName));
        }

        #region IJob メンバ
        public double Maximum { get {return _maximum;} }
        public double Minimum { get {return _minimum;} }
        public double Value   { get {return _value;  } }
        public string Message { get {return _message;} }
        #endregion
               
        #region INotifyPropertyChanged メンバ
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        #endregion

        #region IEnumerator<double> メンバ
        public double Current
        {
            get { return _value; }
        }
        #endregion

        #region IDisposable メンバ
        public void Dispose()
        {
            _disposed = true;
        }
        #endregion

        #region IEnumerator メンバ
        object System.Collections.IEnumerator.Current
        {
            get { return _value; }
        }
        public bool MoveNext()
        {
            if (_disposed)
                return false;

            if(_cnt >= 10000)
                return false;

            System.Threading.Thread.Sleep(10);
            _cnt++;
            _value = _cnt * (_maximum - _minimum) / 10000 + _minimum;

            _message = String.Format("{0}秒待ち 完了", _cnt / 100);
            OnPropertyChangedEvent(string.Empty);
            
            return true;
        }

        public void Reset()
        {
            _cnt = 0;
        }
        #endregion
    }
}
