﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfTimeConsumingApp
{
    /// <summary>
    /// Window1.xaml の相互作用ロジック
    /// </summary>
    public partial class Window1 : Window
    {
        TimeConsumingJob _job;

        public Window1()
        {
            _job = null;

            InitializeComponent();
            setButtonState();
        }

        private void InterruptButton_Click(object sender, RoutedEventArgs e)
        {
            if (null != _job)
                _job.Dispose();

            _job = null;
            setButtonState();
        }

        private void StartButton_Click(object sender, RoutedEventArgs e)
        {
            _job = new TimeConsumingJob();
            this.DataContext = _job;

            //this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new Action<TimeConsumingJob>(this.invokeJob), _job);
            this.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new Action<TimeConsumingJob>(this.invokeJob), _job);
            setButtonState();
        }

        private void ResetButton_Click(object sender, RoutedEventArgs e)
        {
            if (null != _job)
                _job.Reset();

            setButtonState();
        }

        private void setButtonState()
        {
            _startButton.IsEnabled     = (null == _job);
            _resetButton.IsEnabled = !_startButton.IsEnabled;
            _interruptButton.IsEnabled = !_startButton.IsEnabled;
        }

        void invokeJob(TimeConsumingJob job )
        {
            if (null == job)
                return;

            if (!job.MoveNext())
            {
                _status.Text = "実行失敗";
                return;
            }

            if (job.Current >= _job.Maximum)
            {
                _status.Text = "完了";
                return;
            }

            _status.Text = "実行中";
            //this.Dispatcher.Invoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new InvokeJobDelegate(this.invokeJob), job);
            this.Dispatcher.BeginInvoke(System.Windows.Threading.DispatcherPriority.SystemIdle, new Action<TimeConsumingJob>(this.invokeJob), _job);
        }
    }
}
